## grass 6.4.1

=== Makefile ===
#############################################################################
#
# MODULE:   	GRASS Compilation
# AUTHOR(S):	Original author unknown - probably CERL
#   	    	Justin Hickey - Thailand - jhickey AT hpcc.nectec.or.th
#		Markus Neteler - Germany - neteler AT itc.it
#		Andreas Lange - Germany - Andreas.Lange AT Rhein-Main.de
#		Radim Blazek - Italy - blazek AT itc.it
# PURPOSE:  	It provides the commands necessary to compile, install,
#		clean, and uninstall GRASS
#		See INSTALL file for explanations.
# COPYRIGHT:    (C) 2002,2004 by the GRASS Development Team
#
#               This program is free software under the GNU General Public
#   	    	License (>=v2). Read the file COPYING that comes with GRASS
#   	    	for details.
#
#############################################################################

MODULE_TOPDIR = .

include $(MODULE_TOPDIR)/include/Make/Platform.make
include $(MODULE_TOPDIR)/include/Make/Grass.make

# Install directories
exec_prefix=            ${prefix}
BINDIR=			${UNIX_BIN}

# Shell commands
MAKE_DIR_CMD=		mkdir -p -m 755

SUBDIRS = \
	lib \
	db \
	display \
	doc \
	general \
	gui \
	imagery \
	misc \
	ps \
	raster \
	raster3d \
	scripts \
	sites \
	tools \
	vector \
	visualization \
	man \
	macosx

ifeq ($(strip $(MINGW)),)
	SUBDIRS += gem
endif

ifneq ($(strip $(HAVE_NLS)),)
	LOCALE=1
else
	LOCALE=0
endif

FILES = AUTHORS COPYING CHANGES REQUIREMENTS.html contributors.csv  contributors_extra.csv  translators.csv GPL.TXT

BIN_DIST_FILES = $(FILES) \
	grass${GRASS_VERSION_MAJOR}${GRASS_VERSION_MINOR}.tmp \
	bin \
	bwidget \
	docs \
	driver \
	etc \
	fonts \
	include \
	lib \
	man \
	scripts \
	tools

DOXNAME=grass

include $(MODULE_TOPDIR)/include/Make/Docs.make
include $(MODULE_TOPDIR)/include/Make/Doxygen.make

default: builddemolocation
	@echo "GRASS GIS compilation log"     > $(ERRORLOG)
	@echo "-------------------------"    >> $(ERRORLOG)
	@echo "Started compilation: `date`"  >> $(ERRORLOG)
	@echo "--"                           >> $(ERRORLOG)
	@echo "Errors in:"                   >> $(ERRORLOG)
	chmod 755 install-sh
	@list='$(SUBDIRS)'; \
	for subdir in $$list; do \
		$(MAKE) -C $$subdir; \
	done
	$(MAKE) manifests 
	if [ ${LOCALE} -eq 1 ] ; then $(MAKE) -C locale; fi
	-cp -f $(FILES) ${ARCH_DISTDIR}/
	-cp -f ${ARCH_BINDIR}/grass${GRASS_VERSION_MAJOR}${GRASS_VERSION_MINOR} ${ARCH_DISTDIR}/grass${GRASS_VERSION_MAJOR}${GRASS_VERSION_MINOR}.tmp
	@test -d ${ARCH_DISTDIR}/tools/ || mkdir -p ${ARCH_DISTDIR}/tools/
	-${INSTALL} tools/mkhtml.sh ${ARCH_DISTDIR}/tools/ 2>/dev/null
	@(cd tools ; sh -c "./build_html_index.sh")
	@if [ `cat "$(ERRORLOG)" | wc -l` -gt 5 ] ; then \
		echo "--"     >> $(ERRORLOG) ; \
		echo "In case of errors please change into the directory with error and run 'make'." >> $(ERRORLOG) ; \
		echo "If you get multiple errors, you need to deal with them in the order they"      >> $(ERRORLOG) ; \
		echo "appear in the error log. If you get an error building a library, you will"     >> $(ERRORLOG) ; \
		echo "also get errors from anything which uses the library."  >> $(ERRORLOG) ; \
	else \
		echo "No errors detected." >> $(ERRORLOG) ; \
	fi
	@echo "--"  >> $(ERRORLOG)
	@echo "Finished compilation: `date`" >> $(ERRORLOG)
	@cat $(ERRORLOG)
	@if [ `cat "$(ERRORLOG)" | wc -l` -gt 8 ] ; then false ; else true ; fi

manifests:
ifneq ($(strip $(MINGW)),)
	find $(ARCH_DISTDIR) -type f -name '*.exe' | \
	while read file ; do \
	    cmd=`basename "$$file" .exe` ; \
	    sed "s/@CMD@/$$cmd/" mswindows/generic.manifest > "$$file".manifest ; \
	done
endif

LIBDIRS = \
	lib/external/shapelib \
	lib/datetime \
	lib/gis \
	lib/linkm \
	lib/db \
	lib/form \
	lib/vector \
	db/drivers

# Compile libraries only
libs:
	make -C lib/ headers
	@list='$(LIBDIRS)'; \
	for subdir in $$list; do \
		$(MAKE) -C $$subdir; \
	done
	-cp -f $(FILES) ${ARCH_DISTDIR}/
	-cp -fr --parents include ${ARCH_DISTDIR}/

#we leave this target for a while so that people can easily upgrade (11/2004):
mix:
	@echo "NOTE: 'make mix' is no longer needed (changed 9 Nov 2004)"

mixclean:
	list='$(SUBDIRS)'; \
	find include -type l -exec rm {} \; 2>/dev/null; \
	for subdir in $$list; do \
		find $$subdir -type l -exec rm {} \; 2>/dev/null; \
	done
	-rm -f MIX 

# Any target that has a dependency on this target will be forced to be made.
# If we switch to GNU Make then this feature can be replaced with .PHONY
FORCE:

cleandistdirs: 
	-rm -rf ${ARCH_DISTDIR}/bin/         2>/dev/null
	-rm -rf ${ARCH_DISTDIR}/bwidget/     2>/dev/null
	-rm -rf ${ARCH_DISTDIR}/docs/        2>/dev/null
	-rm -rf ${ARCH_DISTDIR}/driver/      2>/dev/null
	-rm -rf ${ARCH_DISTDIR}/etc/         2>/dev/null
	-rm -rf ${ARCH_DISTDIR}/fonts/       2>/dev/null
	-rm -rf ${ARCH_DISTDIR}/include/     2>/dev/null
	-rm -rf ${ARCH_DISTDIR}/lib/         2>/dev/null
	-rm -rf ${ARCH_DISTDIR}/locale/      2>/dev/null
	-rm -rf ${ARCH_DISTDIR}/man/         2>/dev/null
	-rm -rf ${ARCH_DISTDIR}/scripts/     2>/dev/null
	-rm -rf ${ARCH_DISTDIR}/demolocation/ 2>/dev/null
	-rm -rf ${ARCH_DISTDIR}/tcltkgrass/  2>/dev/null
	-rm -rf ${ARCH_DISTDIR}/tools/       2>/dev/null
	-rm -f ${ARCH_DISTDIR}/AUTHORS ${ARCH_DISTDIR}/CHANGES ${ARCH_DISTDIR}/REQUIREMENTS.html ${ARCH_DISTDIR}/COPYING ${ARCH_DISTDIR}/GPL.TXT \
		${ARCH_DISTDIR}/contributors.csv ${ARCH_DISTDIR}/contributors_extra.csv  ${ARCH_DISTDIR}/translators.csv \
		${ARCH_DISTDIR}/grass${GRASS_VERSION_MAJOR}${GRASS_VERSION_MINOR}.tmp 2>/dev/null
	-rmdir ${ARCH_DISTDIR}
	-rm -f ${ARCH_BINDIR}/grass${GRASS_VERSION_MAJOR}${GRASS_VERSION_MINOR} 2>/dev/null
	-rm -f ${ARCH_BINDIR}/grass${GRASS_VERSION_MAJOR}${GRASS_VERSION_MINOR}.bat 2>/dev/null
	-rmdir ${ARCH_BINDIR}

# Clean out the strings extracted from scripts for translation
cleanscriptstrings:
	rm -f locale/scriptstrings/*.c 2>/dev/null

clean: cleandistdirs cleanscriptstrings cleandocs
	@list='$(SUBDIRS)'; \
	for subdir in $$list; do \
		$(MAKE) -C $$subdir clean; \
	done

libsclean: cleandistdirs
	@list='$(LIBDIRS)'; \
	for subdir in $$list; do \
		$(MAKE) -C $$subdir clean; \
	done

distclean: clean
	-rm -f config.cache config.log config.status config.status.${ARCH} 2>/dev/null
	-rm -f ChangeLog ChangeLog.bak $(ERRORLOG) grass.pc
	-rm -f include/config.h include/version.h include/winname.h include/Make/Grass.make 2>/dev/null
	-rm -f include/Make/Platform.make include/Make/Doxyfile_arch_html include/Make/Doxyfile_arch_latex 2>/dev/null

strip: FORCE
	@ if [ ! -f ${ARCH_BINDIR}/grass${GRASS_VERSION_MAJOR}${GRASS_VERSION_MINOR} ] ; then \
		echo "ERROR: GRASS has not been compiled. Try \"make\" first."; \
		echo "  Strip aborted, exiting Make."; \
		exit; \
	fi; \
	cd ${ARCH_DISTDIR} ; find . -type f -perm +111 -exec strip {} \;

install: FORCE
	@ # The following action MUST be a single action. That is, all lines
	@ # except the last line must have a backslash (\) at the end to
	@ # continue the statement. The reason for this is that Make does not
	@ # have an exit command thus, exit terminates the shell. However, 
	@ # Make creates a new shell for each action listed for a target.
	@ # Therefore, the only way exit will quit Make is if there is only
	@ # a single action for the target.
	@ # Check if grass has been compiled, if INST_DIR is writable, and if
	@ # grass is part of INST_DIR
	echo ${ARCH_BINDIR}/grass${GRASS_VERSION_MAJOR}${GRASS_VERSION_MINOR}
	@ if [ ! -f ${ARCH_BINDIR}/grass${GRASS_VERSION_MAJOR}${GRASS_VERSION_MINOR} ] ; then \
		echo "ERROR: GRASS has not been compiled. Try \"make\" first."; \
		echo "  Installation aborted, exiting Make."; \
		exit; \
	fi; \
	if [ "${MACOSX_APP}" = "1" ] ; then \
		${MAKE} install-macosx; \
		exit; \
	fi; \
	INST_PATH=`dirname ${INST_DIR}`; \
	while [ ! -d $$INST_PATH ]; do \
		INST_PATH=`dirname $$INST_PATH`; \
	done; \
	if [ ! -d "${INST_DIR}" -a ! -w "$$INST_PATH" ] ; then \
		echo "ERROR: Directory $$INST_PATH is a parent directory of your"; \
		echo "  install directory ${INST_DIR} and is not writable."; \
		echo "  Perhaps you need root access."; \
		echo "  Installation aborted, exiting Make."; \
		exit; \
	fi; \
	if [ -d ${INST_DIR} -a ! -w "${INST_DIR}" ] ; then \
		echo "ERROR: Your install directory ${INST_DIR} is not writable."; \
		echo "  Perhaps you need root access."; \
		echo "  Installation aborted, exiting Make."; \
		exit; \
	fi; \
	result=`echo "${INST_DIR}" | awk '{ if ($$1 ~ /grass/) print $$1 }'`; \
	if [ "$$result" = "" ] ; then \
		echo "WARNING: Your install directory ${INST_DIR}"; \
		echo "  does not contain the word 'grass'."; \
		echo "  It is highly recommended that the word 'grass' be part"; \
		echo "  of your install directory to avoid conflicts."; \
		echo "  Do you want to continue? [y/n]"; \
		read ans; \
		ans=`echo "$$ans" | tr A-Z a-z`; \
		if [ "$$ans" != "y" ] ; then \
			echo "Installation aborted, exiting Make."; \
			exit; \
		fi; \
	fi; \
	${MAKE} real-install

real-install: FORCE
	test -d ${INST_DIR} || ${MAKE_DIR_CMD} ${INST_DIR}
	@##### test -d ${INST_DIR}/dev || ${MAKE_DIR_CMD} ${INST_DIR}/dev
	test -d ${BINDIR} || ${MAKE_DIR_CMD} ${BINDIR}
	-sed -e "s#GISBASE=.*#GISBASE=${INST_DIR}#" ${ARCH_BINDIR}/grass${GRASS_VERSION_MAJOR}${GRASS_VERSION_MINOR} > ${BINDIR}/grass${GRASS_VERSION_MAJOR}${GRASS_VERSION_MINOR}
	-chmod a+x ${BINDIR}/grass${GRASS_VERSION_MAJOR}${GRASS_VERSION_MINOR}
	-cd ${GISBASE} ; tar cBf - $(FILES) | (cd ${INST_DIR} ; tar xBf - ) 2>/dev/null
	-cd ${GISBASE} ; tar cBf - bin | (cd ${INST_DIR} ; tar xBf - ) 2>/dev/null
	-cd ${GISBASE} ; tar cBf - bwidget | (cd ${INST_DIR} ; tar xBf - ) 2>/dev/null
	-cd ${GISBASE} ; tar cBf - docs | (cd ${INST_DIR} ; tar xBf - ) 2>/dev/null
	-cd ${GISBASE} ; tar cBf - driver | (cd ${INST_DIR} ; tar xBf - ) 2>/dev/null
	-cd ${GISBASE} ; tar cBf - etc | (cd ${INST_DIR} ; tar xBf - ) 2>/dev/null
	-cd ${GISBASE} ; tar cBf - fonts | (cd ${INST_DIR} ; tar xBf - ) 2>/dev/null
ifeq ($(strip $(MINGW)),)
	-cd ${GISBASE} ; tar cBf - man | (cd ${INST_DIR} ; tar xBf - ) 2>/dev/null
endif
	-cd ${GISBASE} ; tar cBf - scripts | (cd ${INST_DIR} ; tar xBf - ) 2>/dev/null
	-cd ${GISBASE} ; tar cBf - tools | (cd ${INST_DIR} ; tar xBf - ) 2>/dev/null
	if [ ${LOCALE} -eq 1 ] ; then cd ${GISBASE} ; tar cBf - locale | (cd ${INST_DIR} ; tar xBf - ) 2>/dev/null ; fi
	@ # The man, include, and lib could go to ${PREFIX}/ BUT if this is
	@ # done, then the corresponding uninstall instructions must delete
	@ # the grass files BY FILENAME NOT DIRECTORY!! Otherwise there is a
	@ # high risk of deleteing system files since PREFIX is defined by
	@ # default to be /usr/local
	@##### -cd ${GISBASE} ; tar cBf - man | (cd ${INST_DIR} ; tar xBf - ) 2>/dev/null
	-cd ${GISBASE} ; tar cBf - include | (cd ${INST_DIR} ; tar xBf - ) 2>/dev/null
	-cd ${GISBASE} ; tar cBf - lib | (cd ${INST_DIR} ; tar xBf - ) 2>/dev/null
	-sed 's#'${GISBASE}'#'${INST_DIR}'#g' ${GISBASE}/etc/monitorcap > ${INST_DIR}/etc/monitorcap
	-sed 's#'${GISBASE}'#'${INST_DIR}'#g' ${GISBASE}/etc/fontcap > ${INST_DIR}/etc/fontcap
	@##### -chmod -R 1777 ${INST_DIR}/locks 2>/dev/null
	-chmod -R a+rX ${INST_DIR} 2>/dev/null
ifeq ($(strip $(MINGW)),)
	@#GEM installation
	-tar cBf - gem/skeleton | (cd ${INST_DIR}/etc ; tar xBf - ) 2>/dev/null
	-${INSTALL} gem/gem$(GRASS_VERSION_MAJOR)$(GRASS_VERSION_MINOR) ${BINDIR} 2>/dev/null
endif
	@# enable OSX Help Viewer
	@if [ "`cat include/Make/Platform.make | grep -i '^ARCH.*darwin'`" ] ; then /bin/ln -sfh "${INST_DIR}/docs/html" /Library/Documentation/Help/GRASS-${GRASS_VERSION_MAJOR}.${GRASS_VERSION_MINOR} ; fi


install-strip: FORCE
	${MAKE} strip
	${MAKE} install

install-macosx: FORCE
	${MAKE} -C macosx install-macosx

bindist:  
	if [ "${MACOSX_APP}" = "1" ] ; then \
		${MAKE} bindist-macosx; \
		exit; \
	fi; \
	${MAKE} real-bindist

real-bindist:
	mkdir -p ${ARCH_DISTDIR}/etc/nad/src ; \
	    cp -f ${MODULE_TOPDIR}/lib/proj/*.lla ${ARCH_DISTDIR}/etc/nad/src ; true

=== locale/Makefile ===
# written by Markus Neteler
# tcl stuff by Cedric Shock
# wxpython by Martin Landa

MODULE_TOPDIR = ..
include $(MODULE_TOPDIR)/include/Make/Module.make

default:
	@if [ "$(HAVE_NLS)" != "" ] ; then \
		echo "Creating translations (= 'make mo')" >&2 ; \
		$(MAKE) mo ; \
	else \
		echo "NLS disabled." ; \
	fi

all:
	@echo 'Usage:'
	@echo '   make pot        create grass.pot (containing original messages)'
	@echo '   make update-po  merge new messages into existing *.po files'
	@echo '   make mo         create the *.mo files'

# Directory for installing tcl .msg files:
MSG_DIR = $(ARCH_DISTDIR)/etc/msgs
NVIZ_DIR = $(ARCH_DISTDIR)/etc/nviz2.2/msgs
MO_DIR = $(ARCH_DISTDIR)/locale
PO_DIR = po

#distinguish between library messages and modules:
LIBDOMAIN = grasslibs
MODDOMAIN = grassmods
TCLDOMAIN = grasstcl
NVIZDOMAIN = grassnviz
WXPYDOMAIN = grasswxpy
DOMAINS = $(LIBDOMAIN) $(MODDOMAIN) $(TCLDOMAIN) $(WXPYDOMAIN)

LIB_POTFILES = find ../lib -name '*.c' | xargs grep -l "_(\""
MOD_POTFILES = find ../ -name '*.c' | grep -v '../lib' | xargs grep -l "_(\""
TCL_POTFILES = find ../ -name '*.tcl' ! -path '../dist*' ! -path '../visualization/nviz/*' | xargs grep -l "\\[_ \|\\[G_msg"
NVIZTCL_POTFILES = find ../visualization/nviz/scripts \( ! -regex '.*/\..*' \) | xargs grep -l "\\[_ \|\\[G_msg"
WXPY_POTFILES = find ../gui/wxpython -name '*.py' | xargs grep -l "_(\""

#The xgettext utility is used to automate the creation of
#portable message files (.po)
pot:
	if [ ! -f ../gui/wxpython/menustrings.py ] ; then \
		echo "Build GRASS before running 'make pot'" >&2 ; \
		exit 1 ; \
	fi
	@echo "Generating $(LIBDOMAIN)..."
	xgettext -k_ -o ./templates/$(LIBDOMAIN).pot `$(LIB_POTFILES)`
	@echo "Generating $(MODDOMAIN)..."
	xgettext -k_ -o ./templates/$(MODDOMAIN).pot `$(MOD_POTFILES)`
	@echo "Generating $(TCLDOMAIN)..."
	xgettext -k_ --keyword=G_msg -o ./templates/$(TCLDOMAIN).pot `$(TCL_POTFILES)`
	@echo "Generating $(NVIZDOMAIN)..."
	xgettext -k_ --keyword=G_msg -L Tcl -o ./templates/$(NVIZDOMAIN).pot `$(NVIZTCL_POTFILES)`
	@echo "Generating $(WXPYDOMAIN)..."
	xgettext -k_ -o ./templates/$(WXPYDOMAIN).pot `$(WXPY_POTFILES)` 

#merge already existing translations with new messages in POT template file and create new po files:
update-po:
	@for i in $(DOMAINS) ; do \
		if [ "`ls ./po/$$i\_*.po 2>/dev/null`" = "" ] ; then \
		 echo "No $$i.po file found in ./po/ directory. Will create new po files from template." ; \
		 cp ./templates/$$i.pot ./po/$$i.po ; \
		 echo "Created ./po/$$i.po - Rename to ./po/$$i\_LANG.po (with LANG: de, ru, ...)" ; \
		 echo "Then you can translate the messages in this file (e.g with kbabel)" ; \
		fi ;\
	done
	@cd ./po/ ; for po in `ls *_*.po 2>/dev/null` ; do \
		suffix=`echo $$po | cut -d'_' -f2-`; \
		lingua=`basename $$suffix .po`; \
		prefix=`echo $$po | cut -d'_' -f1`; \
		if msgmerge -o $$prefix\_$$suffix.new $$prefix\_$$suffix ../templates/$$prefix.pot; then\
		  mv $$prefix\_$$suffix.new $$prefix\_$$suffix; \
		  echo "Merged new messages into $$prefix\_$$suffix" ; \
		else \
		    echo "Merging failed"; \
		fi \
		done
	@echo "Be careful with SVN commits as .po file updates must be syncronized with the individual translators."

libs_FILES := $(patsubst po/grasslibs_%.po,$(MO_DIR)/%/LC_MESSAGES/grasslibs.mo,$(wildcard po/grasslibs_*.po)) 
$(MO_DIR)/%/LC_MESSAGES/grasslibs.mo: po/grasslibs_%.po 
	@ [ -d $(MO_DIR)/$*/LC_MESSAGES ] || $(MKDIR) $(MO_DIR)/$*/LC_MESSAGES 
	msgfmt --statistics -o $@ $< 

mods_FILES := $(patsubst po/grassmods_%.po,$(MO_DIR)/%/LC_MESSAGES/grassmods.mo,$(wildcard po/grassmods_*.po)) 
$(MO_DIR)/%/LC_MESSAGES/grassmods.mo: po/grassmods_%.po 
	@ [ -d $(MO_DIR)/$*/LC_MESSAGES ] || $(MKDIR) $(MO_DIR)/$*/LC_MESSAGES 
	msgfmt --statistics -o $@ $< 

wxpy_FILES := $(patsubst po/grasswxpy_%.po,$(MO_DIR)/%/LC_MESSAGES/grasswxpy.mo,$(wildcard po/grasswxpy_*.po)) 
$(MO_DIR)/%/LC_MESSAGES/grasswxpy.mo: po/grasswxpy_%.po 
	@ [ -d $(MO_DIR)/$*/LC_MESSAGES ] || $(MKDIR) $(MO_DIR)/$*/LC_MESSAGES 
	msgfmt --statistics -o $@ $< 

$(MSG_DIR)/%.msg: po/grasstcl_%.po
	@ [ -d $(MSG_DIR) ] || $(MKDIR) $(MSG_DIR)
	msgfmt --statistics --tcl -l $* -d $(MSG_DIR)/ $<

MSGFILES := $(patsubst po/grasstcl_%.po,$(MSG_DIR)/%.msg,$(wildcard po/grasstcl_*.po))

$(NVIZ_DIR)/%.msg: po/grassnviz_%.po
	@ [ -d $(NVIZ_DIR) ] || $(MKDIR) $(NVIZ_DIR)
	msgfmt --statistics --tcl -l $* -d $(NVIZ_DIR)/ $<

NVIZFILES := $(patsubst po/grassnviz_%.po,$(NVIZ_DIR)/%.msg,$(wildcard po/grassnviz_*.po))

#create binary messages files
mo: $(libs_FILES) $(mods_FILES) $(wxpy_FILES) $(MSGFILES) $(NVIZFILES)

.PHONY: mo

=== raster/Makefile ===
MODULE_TOPDIR = ..

SUBDIRS = \
	r.average \
	r.basins.fill \
	r.bilinear \
	r.bitpattern \
	r.buffer \
	r.carve \
	r.cats \
	r.circle \
	r.clump \
	r.coin \
	r.colors \
	r.colors.out \
	r.composite \
	r.compress \
	r.contour \
	r.cost \
	r.covar \
	r.cross \
	r.describe \
	r.distance \
	r.drain \
	r.external \
	r.fill.dir \
	r.flow \
	r.grow2 \
	r.grow.distance \
	r.gwflow \
	r.horizon \
	r.his \
	r.in.arc \
	r.in.ascii \
	r.in.bin \
	r.info \
	r.in.gridatb \
	r.in.mat \
	r.in.poly \
	r.in.xyz \
	r.kappa \
	r.lake \
	r.le \
	r.los \
	r.mapcalc \
	r.median \
	r.mfilter \
	r.mfilter.fp \
	r.mode \
	r.neighbors \
	r.null \
	r.out.arc \
	r.out.ascii \
	r.out.bin \
	r.out.gridatb \
	r.out.mat \
	r.out.mpeg \
	r.out.pov \
	r.out.ppm \
	r.out.ppm3 \
	r.out.vrml \
	r.out.vtk \
	r.param.scale \
	r.patch \
	r.profile \
	r.proj.seg \
	r.quant \
	r.quantile \
	r.random \
	r.random.cells \
	r.random.surface \
	r.reclass \
	r.recode \
	r.region \
	r.report \
	r.resample \
	r.resamp.interp \
	r.resamp.rst \
	r.resamp.stats \
	r.rescale \
	r.rescale.eq \
	r.series \
	r.slope.aspect \
	r.statistics \
	r.stats \
	r.sum \
	r.sun2 \
	r.sunmask \
	r.support \
	r.support.stats \
	r.surf.area \
	r.surf.contour \
	r.surf.idw \
	r.surf.idw2 \
	r.surf.random \
	r.surf.gauss \
	r.texture \
	r.thin \
	r.timestamp \
	r.to.rast3 \
	r.to.rast3elev \
	r.to.vect \
	r.topidx \
	r.topmodel \
	r.transect \
	r.univar2 \
	r.volume \
	r.walk \
	r.water.outlet \
	r.watershed \
	r.what \
	r.what.color \
	simwe \
	wildfire

GDALBASED = r.in.gdal r.out.gdal

FFTWBASED = r.surf.fractal

PNGBASED = r.out.png

CXXBASED = r.terraflow

TIFFBASED = r.out.tiff

XMONBASED = r.digit


include $(MODULE_TOPDIR)/include/Make/Platform.make

ifndef MINGW
    SUBDIRS += r.li
endif

#compile if GDAL present:
ifneq ($(USE_GDAL),)
    SUBDIRS += $(GDALBASED)
endif

#compile if FFTW present:
ifneq ($(strip $(FFTWLIB)),)
    SUBDIRS += $(FFTWBASED)
endif

#compile if PNG present:
ifneq ($(strip $(PNGLIB)),)
    SUBDIRS += $(PNGBASED)
endif

#compile if C++ compiler present:
ifneq ($(strip $(CXX)),)
    SUBDIRS += $(CXXBASED)
endif

#compile if TIFF present:
ifneq ($(strip $(TIFFLIB)),)
    SUBDIRS += $(TIFFBASED)
endif

#compile if interactive Xmons are present:
ifneq ($(USE_X11),)
    SUBDIRS += $(XMONBASED)
endif


PGM = rasterintro

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: htmldir

htmldir: parsubdirs 

clean: cleansubdirs

=== scripts/Makefile ===
MODULE_TOPDIR = ..

SUBDIRS = \
	d.correlate \
	d.font.freetype \
	d.monsize \
	d.mvmon \
	d.out.gpsdrive \
	d.out.png \
	d.out.file \
	d.paint.labels \
	d.polar \
	d.rast.edit \
	d.rast.leg \
	d.redraw \
	d.resize \
	d.shadedmap \
	d.slide.show \
	d.split \
	d.split.frame \
	d.text.freetype \
	d.vect.thematic \
	db.dropcol \
	db.droptable \
	db.in.ogr \
	db.out.ogr \
	db.test \
	g.manual \
	g.extension \
	i.fusion.brovey \
	i.image.mosaic \
	i.in.spotvgt \
	i.landsat.rgb \
	i.oif \
	i.spectral \
	i.tasscap \
	m.proj \
	p.out.vrml \
	r.blend \
	r.cats \
	r.colors.stddev \
	r.fillnulls \
	r.in.aster \
	r.in.srtm \
	r.in.wms \
	r.mapcalculator \
	r.mask \
	r.out.gdal \
	r.out.xyz \
	r.plane \
	r.reclass.area \
	r.regression.line \
	r.shaded.relief \
	r.tileset \
	r.univar.sh \
	r3.mapcalculator \
	v.build.all \
	v.centroids \
	v.colors \
	v.convert.all \
	v.db.addcol \
	v.db.addtable \
	v.db.join \
	v.db.dropcol \
	v.db.droptable \
	v.db.renamecol \
	v.db.reconnect.all \
	v.db.univar \
	v.db.update \
	v.dissolve \
	v.in.e00 \
	v.in.garmin \
	v.in.geonames \
	v.in.gns \
	v.in.gpsbabel \
	v.in.lines \
	v.in.mapgen \
	v.in.sites.all \
	v.in.wfs \
	v.out.gpsbabel \
	v.rast.stats \
	v.report \
	v.univar.sh \
	v.what.vect

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: parsubdirs

clean: cleansubdirs

=== gui/wxpython/Makefile ===
MODULE_TOPDIR = ../..

SUBDIRS = docs scripts
EXTRA_CLEAN_FILES = menustrings.py build_ext.pyc
CLEAN_SUBDIRS = scripts

include $(MODULE_TOPDIR)/include/Make/Dir.make
include $(MODULE_TOPDIR)/include/Make/Doxygen.make
include $(MODULE_TOPDIR)/include/Make/Python.make

ETCDIR = $(ETC)/wxpython

SRCFILES := $(wildcard compat/* gui_modules/* icons/*.* icons/silk/* images/* xml/*) gis_set.py wxgui.py README
DSTFILES := $(patsubst %,$(ETCDIR)/%,$(SRCFILES)) $(patsubst %.py,$(ETCDIR)/%.pyc,$(filter %.py,$(SRCFILES)))

default: install_scripts
	$(MAKE) parsubdirs

clean: cleansubdirs

install_scripts:
	-for dir in '' compat gui_modules icons icons/silk images xml; do \
	if [ ! -d $(ETCDIR)/$$dir ] ; then $(MKDIR) $(ETCDIR)/$$dir ; fi ; \
	done
	$(MAKE) $(DSTFILES)
	$(MAKE) menustrings.py

$(ETCDIR)/%: %
	$(INSTALL_DATA) $< $@

menustrings.py: gui_modules/menudata.py $(ETCDIR)/xml/menudata.xml $(ETCDIR)/xml/menudata_modeler.xml 
	GISBASE="$(GISBASE)" \
	$(PYTHON) $< > $@
	GISBASE="$(GISBASE)" \
	$(PYTHON) $< "modeler" >> $@

#doxygen:
DOXNAME=wxpython

=== lib/init/Makefile ===
#############################################################################
#
# MODULE:   	GRASS Initialization
# AUTHOR(S):	Original author unknown - probably CERL
#   	    	Justin Hickey - Thailand - jhickey@hpcc.nectec.or.th
#               Markus Neteler, Andrea Antonello
# PURPOSE:  	To create the various scripts and programs which are required
#   	    	to start GRASS.
# COPYRIGHT:    (C) 2000-2008 by the GRASS Development Team
#
#               This program is free software under the GNU General Public
#   	    	License (>=v2). Read the file COPYING that comes with GRASS
#   	    	for details.
#
#############################################################################

MODULE_TOPDIR = ../..

include $(MODULE_TOPDIR)/include/Make/Platform.make
include $(MODULE_TOPDIR)/include/Make/Grass.make
include $(MODULE_TOPDIR)/include/Make/Rules.make

START_UP=grass$(GRASS_VERSION_MAJOR)$(GRASS_VERSION_MINOR)

EXTRA_CFLAGS = -DD_LOCATION_NAME=\"$(DEFAULT_LOCATION)\" -DD_GISDBASE=\"$(DEFAULT_DATABASE)\" -DGRASS_VERSION_NUMBER=\"'$(GRASS_VERSION_NUMBER)'\" -DGRASS_VERSION_UPDATE_PKG=\"'$(GRASS_VERSION_UPDATE_PKG)'\"
SET_DATA = $(OBJDIR)/set_data.o $(OBJDIR)/mke_mapset.o \
	   $(OBJDIR)/mke_loc.o $(OBJDIR)/chk_dbase.o $(OBJDIR)/other.o

ifdef USE_CURSES
SET_DATA_PROG = $(ETC)/set_data$(EXE)
else
SET_DATA_PROG =
endif

FILES = \
	$(ARCH_BINDIR)/$(START_UP) \
	$(ETC)/Init.sh \
	$(ETC)/prompt.sh \
	$(SET_DATA_PROG) \
	$(ETC)/clean_temp$(EXE) \
	$(ETC)/lock$(EXE) \
	$(ETC)/run$(EXE) \
	$(ETC)/echo$(EXE) \
	$(ETC)/grass_intro \
	$(ETC)/license \
	$(ETC)/welcome \
	$(ETC)/VERSIONNUMBER \
	$(ETC)/gis_set.tcl \
	$(ETC)/epsg_option.tcl \
	$(ETC)/file_option.tcl \
	$(ETC)/grass-run.sh \
	$(ETC)/grass-xterm-wrapper

ifeq ($(findstring darwin,$(ARCH)),darwin)
	FILES += \
		$(ETC)/grass-xterm-mac \
		$(ETC)/html_browser_mac.sh
endif

ifneq ($(strip $(MINGW)),)
	FILES += \
		$(ETC)/Init.bat \
		$(ETC)/winlocale$(EXE) \
		$(ETC)/grass-run.bat
endif

default: $(FILES)
	$(MKDIR) $(GISBASE)/docs/html
	$(INSTALL_DATA) variables.html $(GISBASE)/docs/html/variables.html
	$(INSTALL_DATA) grass6.html $(GISBASE)/docs/html/grass6.html
	$(INSTALL_DATA) helptext.html $(GISBASE)/docs/html/helptext.html
	$(INSTALL_DATA) help_loc_struct.png $(GISBASE)/docs/html/help_loc_struct.png
	$(INSTALL_DATA) circle_*.png $(GISBASE)/docs/html/
	$(INSTALL_DATA) grass_start.png $(GISBASE)/docs/html/

$(ARCH_BINDIR)/$(START_UP): init.sh grass.src
	@test -d $(ARCH_BINDIR) || (echo 'ARCH_DISTDIR($(ARCH_BINDIR))' not found; exit 1)
	@test -w $(ARCH_BINDIR) || (echo '($(ARCH_BINDIR))' not writeable; exit 1)
	rm -f $(ARCH_BINDIR)/$(START_UP) ; true
	$(SHELL) -c "sed \
	-e \"s#GISBASE_VALUE#$(GISBASE)#\" \
	grass.src > $(ARCH_BINDIR)/$(START_UP) 2>/dev/null ; true"
	chmod a+x $(ARCH_BINDIR)/$(START_UP)

$(ETC)/Init.sh: init.sh
	rm -f $@
	$(SHELL) -c "sed \
	-e \"s#GRASS_VERSION_NUMBER#$(GRASS_VERSION_NUMBER)#\" \
	-e \"s#GRASS_VERSION_DATE#$(GRASS_VERSION_DATE)#\" \
	-e \"s#GRASS_VERSION_UPDATE_PKG#$(GRASS_VERSION_UPDATE)#\" \
	-e \"s#LD_LIBRARY_PATH_VAR#$(LD_LIBRARY_PATH_VAR)#g\" \
	-e \"s#PERL_COMMAND#$(PERL)#\" \
	-e \"s#START_UP#$(START_UP)#\" \
	-e \"s#CONFIG_PROJSHARE#$(PROJSHARE)#\" \
	init.sh > $@"
	chmod +x $@

$(ETC)/Init.bat: init.bat
	rm -f $@
	$(SHELL) -c "sed \
	-e \"s#GRASS_VERSION_NUMBER#$(GRASS_VERSION_NUMBER)#\" \
	-e \"s#CONFIG_PROJSHARE#$(PROJSHARE)#\" \
	$< > $@"
	chmod +x $@

$(ETC)/set_data$(EXE): $(SET_DATA)
	$(CC) $(LDFLAGS) -o $@ $(SET_DATA) $(EDITLIB) $(GISLIB) $(DATETIMELIB) $(VASKLIB) $(CURSES) $(MATHLIB) $(XDRLIB)

$(ETC)/echo$(EXE): $(OBJDIR)/echo.o
	$(CC) $(LDFLAGS) $(OBJDIR)/echo.o -o $@

$(ETC)/clean_temp$(EXE): $(OBJDIR)/clean_temp.o  
	$(CC) $(LDFLAGS) $(OBJDIR)/clean_temp.o $(GISLIB) $(DATETIMELIB) $(MATHLIB) $(XDRLIB) -o $@

$(ETC)/run$(EXE): $(OBJDIR)/run.o
	$(CC) $(LDFLAGS) $(OBJDIR)/run.o -o $@

$(ETC)/lock$(EXE): $(OBJDIR)/lock.o
	$(CC) $(LDFLAGS) $(OBJDIR)/lock.o $(GISLIB) $(DATETIMELIB) $(MATHLIB) $(XDRLIB) -o $@

$(BIN)/exit:
	touch $@
	chmod 600 $@

$(ETC)/winlocale$(EXE): $(OBJDIR)/winlocale.o
	$(CC) $(LDFLAGS) $(EXTRA_LDFLAGS) -o $@ $^ -lkernel32

$(ETC)/VERSIONNUMBER:
	rm -f $@
	echo "$(GRASS_VERSION_NUMBER)" > $@
	chmod +r $@

$(ETC)/grass_intro: grass_intro.txt version.sed 
	rm -f $@
	sh ./version.sed "$(GRASS_VERSION_NUMBER)" "$(GRASS_VERSION_DATE)" "$(GRASS_VERSION_UPDATE_PKG)" grass_intro.txt > $@
	chmod +r $@

$(ETC)/license: license.txt version.sed
	rm -f $@
	sh ./version.sed "$(GRASS_VERSION_NUMBER)" "$(GRASS_VERSION_DATE)" "$(GRASS_VERSION_UPDATE_PKG)" license.txt > $@
	chmod +r $@

$(ETC)/welcome: welcome.txt version.sed
	rm -f $@
	sh ./version.sed "$(GRASS_VERSION_NUMBER)" "$(GRASS_VERSION_DATE)" "$(GRASS_VERSION_UPDATE_PKG)" welcome.txt > $@
	chmod +r $@

$(ETC)/msgs: msgs
	rm -rf $@
	$(MKDIR) $@
	$(INSTALL_DATA) msgs/*.msg $@	

$(ETC)/gis_set.tcl: gis_set.tcl
	rm -f $@
	$(INSTALL) gis_set.tcl $(ETC)

$(ETC)/epsg_option.tcl: epsg_option.tcl
	rm -f $@
	$(INSTALL) epsg_option.tcl $(ETC)

$(ETC)/file_option.tcl: file_option.tcl
	rm -f $@
	$(INSTALL) file_option.tcl $(ETC)

$(ETC)/grass-run.sh: grass-run.src
	rm -f $@
	$(SHELL) -c "sed \
	-e \"s#LD_LIBRARY_PATH_VAR#$(LD_LIBRARY_PATH_VAR)#g\" \
	grass-run.src > $@"
	chmod +x $@

$(ETC)/grass-run.bat: grass-run.bat
	$(INSTALL) grass-run.bat $(ETC)

$(ETC)/grass-xterm-wrapper: grass-xterm-wrapper
	$(INSTALL) grass-xterm-wrapper $(ETC)

$(ETC)/grass-xterm-mac: grass-xterm-mac
	$(INSTALL) grass-xterm-mac $(ETC)

$(ETC)/prompt.sh: prompt.sh
	rm -f $@
	$(INSTALL) prompt.sh $(ETC)

$(ETC)/html_browser_mac.sh: html_browser_mac.sh
	$(INSTALL) html_browser_mac.sh $(ETC)

=== lib/python/Makefile ===
MODULE_TOPDIR = ../..

include $(MODULE_TOPDIR)/include/Make/Platform.make
include $(MODULE_TOPDIR)/include/Make/Grass.make
include $(MODULE_TOPDIR)/include/Make/Rules.make
include $(MODULE_TOPDIR)/include/Make/Doxygen.make

PYDIR = $(ETC)/python
GDIR = $(PYDIR)/grass
DSTDIR = $(GDIR)/script

MODULES = core db raster vector array setup

PYFILES := $(patsubst %,$(DSTDIR)/%.py,$(MODULES) __init__)

default: $(DSTDIR)
	$(MAKE) $(PYFILES)
EXTRA_CLEAN_FILES = setup.py

$(PYDIR):
	test -d $@ || $(MKDIR) -p $@

$(GDIR): $(PYDIR)
	test -d $@ || $(MKDIR) -p $@

$(DSTDIR): $(GDIR)
	test -d $@ || $(MKDIR) -p $@
	@cat grass__init__.py > $(GDIR)/__init__.py

$(DSTDIR)/%: %
	$(INSTALL_DATA) $< $@

setup.py: setup.py.sed
	sed \
	-e 's#@LD_LIBRARY_PATH_VAR@#$(LD_LIBRARY_PATH_VAR)#' \
	$< > $@

#doxygen:
DOXNAME = python

=== gui/wxpython/docs/Makefile ===
MODULE_TOPDIR = ../../..

FILES = wxGUI \
	wxGUI.Vector_Digitizer \
	wxGUI.Attribute_Table_Manager \
	wxGUI.Nviz \
	wxGUI.Icons \
	wxGUI.Modeler \
	wxGUI.GCP_Manager

include $(MODULE_TOPDIR)/include/Make/Platform.make
include $(MODULE_TOPDIR)/include/Make/Grass.make
include $(MODULE_TOPDIR)/include/Make/Rules.make

default:
	for file in $(FILES) ; do \
	    rm -f $$file.tmp.html ; \
	    rm -f "$(GISBASE)/docs/html/$$file.html"; \
	    $(MAKE) htmldir PGM=$$file; \
	done

=== gui/wxpython/scripts/Makefile ===
MODULE_TOPDIR = ../../..

include $(MODULE_TOPDIR)/include/Make/Dir.make
include $(MODULE_TOPDIR)/include/Make/Python.make

SCRIPTDIR = $(ETC)/wxpython/scripts

ifdef MINGW
PYFILES := $(patsubst %.py, $(SCRIPTDIR)/%.py, $(filter %.py, $(PY_SOURCES)))
else
PYFILES := $(patsubst %.py, $(SCRIPTDIR)/%, $(filter %.py, $(PY_SOURCES)))
endif

default: install_scripts

install_scripts:
	$(MAKE) $(PYFILES)

$(SCRIPTDIR)/%: %.py | $(SCRIPTDIR)
	$(INSTALL) $< $@

$(SCRIPTDIR)/%.py: %.py | $(SCRIPTDIR)
	$(INSTALL) $< $@

$(SCRIPTDIR):
	-test -d $@ | $(MKDIR) $@

=== gui/wxpython/vdigit/Makefile ===
MODULE_TOPDIR = ../../..

include $(MODULE_TOPDIR)/include/Make/Lib.make

# substitute OSX arch flags for wxpython
ifneq ($(MACOSX_ARCHS),)
CFLAGS := $(subst $(MACOSX_ARCHS),,$(CFLAGS)) $(MACOSX_ARCHS_WXPYTHON)
CXXFLAGS := $(subst $(MACOSX_ARCHS),,$(CXXFLAGS)) $(MACOSX_ARCHS_WXPYTHON)
LDFLAGS := $(subst $(MACOSX_ARCHS),,$(LDFLAGS)) $(MACOSX_ARCHS_WXPYTHON)
endif

LIB_NAME = grass6_wxvdigit

SHLIB = $(OBJDIR)/_$(LIB_NAME).so

ETCDIR = $(ETC)/wxpython

EXTRA_CLEAN_FILES = grass6_wxvdigit.py grass6_wxvdigit.i grass6_wxvdigit_wrap.cpp
default:

ifneq ($(USE_WXWIDGETS),)
ifneq ($(USE_PYTHON),)
ifneq ($(strip $(CXX)),)
default: install_vdigit
endif
endif
endif

$(LIB_NAME).i: digit.i dig_types.i pseudodc.i driver.h digit.h
	cat digit.i pseudodc.i dig_types.i > $(LIB_NAME).i
	echo "/* auto-generated swig typedef file */" >> $(LIB_NAME).i
	cat driver.h digit.h >> $(LIB_NAME).i

$(LIB_NAME).py: $(SHLIB)

$(SHLIB): $(LIB_NAME).i cats.cpp digit.cpp driver.cpp driver_draw.cpp \
	driver_select.cpp line.cpp message.cpp select.cpp undo.cpp vertex.cpp
	$(PYTHON) setup.py build_ext --swig=swig --swig-opts=-c++ --build-lib=$(OBJDIR) --build-temp=$(OBJDIR)

.NOTPARALLEL: $(LIB_NAME).py $(LIB_NAME)_wrap.cpp

install_vdigit: $(ETCDIR)/vdigit $(ETCDIR)/vdigit/_$(LIB_NAME).so $(ETCDIR)/vdigit/$(LIB_NAME).py

$(ETCDIR)/vdigit:
	$(MKDIR) $@

$(ETCDIR)/vdigit/_$(LIB_NAME).so: $(SHLIB)
	$(INSTALL) $< $@

$(ETCDIR)/vdigit/$(LIB_NAME).py: $(LIB_NAME).py
	$(INSTALL_DATA) $< $@

=== visualization/nviz/src/Makefile ===
# Makefile for building nvwish
# Requires Tk 8.x and Tcl 8.x

MODULE_TOPDIR = ../../..

include $(MODULE_TOPDIR)/include/Make/Platform.make
include $(MODULE_TOPDIR)/include/Make/Grass.make
include $(MODULE_TOPDIR)/include/Make/Rules.make

# These should be set by the doconfigure script
NVWISH_VER=NVWISH2.2

ifeq ($(OPENGL_X11),1)
OGL_LIBS := $(OPENGLULIB) $(OPENGLLIB) $(XLIBPATH) $(XLIB) -lXmu -lXext $(XEXTRALIBS) $(MATHLIB)
endif
ifeq ($(OPENGL_WINDOWS),1)
OGL_LIBS := $(OPENGLULIB) $(OPENGLLIB) -lgdi32 $(MATHLIB)
endif
ifeq ($(OPENGL_AQUA),1)
OGL_LIBS := $(OPENGLULIB) $(OPENGLLIB) $(MATHLIB)
endif
# substitute OSX arch flags for tcltk
ifneq ($(MACOSX_ARCHS),)
CFLAGS := $(subst $(MACOSX_ARCHS),,$(CFLAGS)) $(MACOSX_ARCHS_TCLTK)
LDFLAGS := $(subst $(MACOSX_ARCHS),,$(LDFLAGS)) $(MACOSX_ARCHS_TCLTK)
endif

SURFLIB = $(OGSFLIB)

# Stuff for mkdspf - not yet implemented
# DSPLIB = $(LIBDIR)/libes/dspf/libdsp3.a
# DSPINC = -I$(LIBDIR)/libes/dspf

EXTRA_INC = $(VECT_INC)
EXTRA_CFLAGS= $(TCLINCDIR) $(TKINCDIR) \
	$(INC) \
	$(TIFFINCPATH) $(DSPINC) \
	$(VECT_CFLAGS) $(OPENGLINC) -D USE_INTERP_RESULT

ifeq ($(OPENGL_X11),1)
EXTRA_CFLAGS += $(XCFLAGS)
endif

XTRA_LDFLAGS=$(TCLTKLIBPATH) $(TCLTKLIBS) $(OGL_LIBS)

OBJS = nvizAppInit.o change_view.o draw.o exag.o glwrappers.o \
	init_commands.o lights.o map_obj.o misc.o nviz_init.o \
	position.o quick_draw.o anim_support.o cutplane_obj.o \
	script_support.o do_zoom.o \
	label.o nvizMain.o togl.o togl_cb.o\
	query_vect.o \
	volume.o \
	togl_flythrough.o pick_vect_commands.o site_attr_commands.o site_highlight_commands.o

# mkdspf_calc_linefax.o mkdspf_init_file.o mkdspf_main.o \
# mkdspf_fill_cfax.o mkdspf_iso_surface.o

ARCH_OBJS := $(foreach obj,$(OBJS),$(OBJDIR)/$(obj)) 

EXTRA_CLEAN_FILES = nvwish$(EXE)

#default: $(BIN)/$(PGM) htmlcmd
default: nvwish$(EXE)

nvwish$(EXE): $(ARCH_OBJS) $(VECTDEP) $(BITMAPDEP) $(LINKMDEP) $(FORMDEP) $(DBMIDEP $(GISDEP)
	$(CC) $(LDFLAGS) -o $@ $(ARCH_OBJS) $(FMODE_OBJ) $(SURFLIB) $(XTRA_LDFLAGS) \
		$(BITMAPLIB) $(LINKMLIB) $(VECTLIB) $(SITESLIB) $(FORMLIB) $(DBMILIB) \
		$(G3DLIB) $(GISLIB) $(XDRLIB) \
		$(DATETIMELIB) $(TIFFLIBPATH) $(TIFFLIB) \
		$(MATHLIB)
	-$(MKDIR) $(GISBASE)/docs/html
	-$(INSTALL_DATA) description.html $(GISBASE)/docs/html/nviz.html
	-$(INSTALL) *.png *.jpg $(GISBASE)/docs/html 2> /dev/null ; true

=== visualization/nviz2/cmd/Makefile ===
MODULE_TOPDIR = ../../..

PGM = nviz_cmd

ifeq ($(OPENGL_X11),1)
OGL_LIBS := $(OPENGLULIB) $(OPENGLLIB) $(XLIBPATH) $(XLIB) -lXmu -lXext $(XEXTRALIBS) $(MATHLIB)
endif
ifeq ($(OPENGL_WINDOWS),1)
OGL_LIBS := $(OPENGLULIB) $(OPENGLLIB) -lgdi32 $(MATHLIB)
endif
ifeq ($(OPENGL_AQUA),1)
OGL_LIBS := $(OPENGLULIB) $(OPENGLLIB) $(MATHLIB)
endif

EXTRA_INC = $(VECT_INC)
EXTRA_CFLAGS = $(INC) \
	$(TIFFINCPATH) $(DSPINC) \
	$(VECT_CFLAGS) $(OPENGLINC) 

ifeq ($(OPENGL_X11),1)
EXTRA_CFLAGS += $(XCFLAGS)
endif

EXTRA_LDFLAGS = $(OGL_LIBS)

LIBES = $(GISLIB) $(OGSFLIB) $(NVIZLIB) $(G3DLIB)
DEPENDENCIES = $(GISDEP) $(NVIZDEP)

include $(MODULE_TOPDIR)/include/Make/Module.make

ifneq ($(USE_OPENGL),)
default: cmd
endif

=== debian/changelog ===
grass (6.4.1-2) unstable; urgency=low

  [ Hamish Bowman ]
  * Desktop icon cleanup.
  * Recommend wx; suggest gs, python-imaging, python-rpy2.
  * Remove more obsolete swig references.
  * grass-dev: further support for building add-ons.

  [ Francesco Paolo Lovergine ]
  * Now reset debian/rules to use wx-config current alternative.
    (closes: #655799)
  * Now added python-support to manage compiled python modules.
    This makes lintian happy about package-installs-python-bytecode.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Thu, 19 Jan 2012 14:04:52 +0100

grass (6.4.1-1) unstable; urgency=low

  * New upstream version.
  * Now build-dep on libjpeg-dev and current libreadline6-dev.
  * Removed patch swig: obsolete.
  * Policy bumped to 3.9.2, without changes.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Wed, 13 Apr 2011 17:08:41 +0200

grass (6.4.0-2) unstable; urgency=low

  * Ready for unstable.
  * Removed pre-release patches inserted in the squeeze latest upload.

  * Merged from 6.4.0-1 in experimental:
      - Added missing docs used by GUIs: AUTHORS, contributors CSV files,
        COPYING and a symlink to GPL-2 license in /usr/share/common-licenses.
        Those files need to be symlinked in GISBASE to be found at run-time.
        Thanks AlanB and Hamish for pointing the problem.
        (closes: #594492)
      - New upstream final release 6.4.0.
      - Note that now default interface is the wx one, so (wx)python related suggestions
        have been promoted to proper dependencies. For the same reason I would
        consider cut/paste problems of the past Tk interface obsolete.
        (closes: #305249)
      - Policy bumped to 3.9.1. No changes required.
      - Added libgdal1-dev dep to grass-dev list of dependencies.
        (closes: #598706)

  * Merged from 6.4.0~rc6+42329-3:
      - Now builds against Tcl/Tk >= 8.5.
        (closes: #582595)
      - Removed obsolete grass-doc conflicts/replaces.

  * Moved to source format 3.0 and quilt patch support.
  * Moved from svn to git and updated Vcs-* fields in debian/control* as due.
  * Merged experimental changelogs.
  * Now saves and restores upstream config.{sub|guess} to avoid annoying warnings.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Wed, 16 Feb 2011 17:04:43 +0100

grass (6.4.0-1) experimental; urgency=low

  * New upstream final release.
  * Note that now default interface is the wx one, so (wx)python related suggestions
    have been promoted to proper dependencies. For the same reason I would
    consider cut/paste problems of the past Tk interface obsolete.
    (closes: #305249)
  * Policy bumped to 3.9.1. No changes required.
  * Added libgdal1-dev dep to grass-dev list of dependencies.
    (closes: #598706)
  * Merged from 6.4.0~rc6+42329-3:
         Added missing docs used by GUIs: AUTHORS, contributors CSV files,
         COPYING and a symlink to GPL-2 license in /usr/share/common-licenses.
         Those files need to be symlinked in GISBASE to be found at run-time.
         Thanks AlanB and Hamish for pointing the problem.
         (closes: #594492)

 -- Francesco Paolo Lovergine <frankie@debian.org>  Thu, 14 Oct 2010 16:08:06 +0200

grass (6.4.0~rc6+42329-3) unstable; urgency=low

  * Merging main fixes taken from final 6.4.0 release. The big patch has been
    splitted in a few sub-patches for specific improvements.
        + localization.dpatch: updates to .po files.
        + doc.dpatch: various documentation fixes with update to main URL too. 
        + gcs.dpatch: Port GDAL's http://trac.osgeo.org/gdal/changeset/19810 
              to fix missing towsg84 for EPSG codes: 3120 2172 2173 2174 2175 
              3333 3334 3335 3329 3330 3331 3332 3328 4179. 
              It also forces ETRS89 datum to be
              interpreted as 0,0,0,0,0,0,0 instead of 0.000,0.000,0.000 (i.e.
              overrides the datum.table ETRS89 setting, too). More info:
              http://lists.osgeo.org/pipermail/grass-dev/2010-June/050918.html,
              http://trac.osgeo.org/gdal/ticket/3579.
        + g.extension.dpatch: added Markus g.extension script to download and
          eventually install extension from GRASS svn add-ons repo.
        + scripts.dpatch: some fixes to a blounce of scripts: 
                m.proj - added GUI section
                r.mask - allow r.mask to work in GISDBASE
                v.in.gpsbabel - fixed broken awk statement
                v.in.mapgen - better describe what v.in.mapgen will load
                r.regression.line -  rename variable from italian so it 
                     doesn't get confused with median, add F-test to key
        + g.proj: only split at space characters if there is a + character
                  following
        + clean_nodes: in Vlib fixes segfault when cleaning small angles 
                   at nodes
        + read_sig.c: catch empty sig files
        + convert.c: added non-standard datum name lookup
        + r.grow.distance: bugfix for distance calculation
        + geom.c: fixes bug for min_area
        + flythrough: fixes NVIZ fly mode on 64bit. See #46 from upstream trac.
        + filldepr.cc: r.terraflow: backport fix for #1006 from upstream trac.
  * Added missing docs used by GUIs: AUTHORS, contributors CSV files, 
    COPYING and a symlink to GPL-2 license in /usr/share/common-licenses.
    Those files need to be symlinked in GISBASE to be found at run-time.
    Thanks AlanB and Hamish for pointing the problem.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Tue, 21 Sep 2010 16:45:05 +0200

grass (6.4.0~rc6+42329-2) experimental; urgency=low

  * Now builds against Tcl/Tk 8.5.
    (closes: #582595)
  * Removed obsolete grass-doc conflicts/replaces.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Tue, 01 Jun 2010 14:38:01 +0200

grass (6.4.0~rc6+42329-1) unstable; urgency=low

  * New upstream snapshot with some fixes in modules.



=== debian/control ===
Source: grass
Section: science
Priority: optional
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>
Build-depends: flex, bison, libreadline-dev | libreadline6-dev, libncurses5-dev, lesstif2-dev, debhelper (>= 8), 
 libtiff4-dev, tcl-dev (>= 8.5), tk-dev (>= 8.5), libfftw3-dev, libxmu-dev, libglu1-mesa-dev | libglu1-xorg-dev, 
 libfreetype6-dev, autoconf2.13, autotools-dev, libgdal1-dev (>= 1.5.0), libproj-dev, proj-bin, libjpeg-dev, 
 libpng12-dev, libpq-dev, unixodbc-dev, doxygen, fakeroot, libmysqlclient15-dev, graphviz, libsqlite3-dev, python-wxgtk2.8,
 libcairo2-dev, libwxgtk2.8-dev, python-dev (>= 2.5), python-support (>= 0.90)
Standards-Version: 3.9.2
Build-Conflicts: wx2.6-headers
Homepage: http://grass.osgeo.org/
Vcs-Browser: http://git.debian.org/?p=pkg-grass/grass.git
Vcs-Git: git://git.debian.org/git/pkg-grass/grass.git

Package: grass
Section: science
Architecture: any
Depends: ${shlibs:Depends}, xterm | x-terminal-emulator, python-numpy,
 python-opengl, python-wxgtk2.8, ${misc:Depends}, ${python:Depends}
Suggests: grass-doc, gdal-bin, proj-bin, e00compr, avce00, gpsbabel, gpstrans,
 gnuplot, xml2, wget | curl, netpbm
Recommends: ghostscript, python-wxgtk2.8
Provides: grass641
Description: Geographic Resources Analysis Support System 
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.

Package: grass-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Geographic Resources Analysis Support System documentation
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains HTML documentation for the GRASS system.

Package: grass-dev
Section: devel
Architecture: any
Depends: grass (= ${binary:Version}), fakeroot, libproj-dev, libgdal1-dev, ${misc:Depends}
Suggests: pkg-config
Provides: grass64-dev
Description: GRASS GIS development files
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains the header files for developing with GRASS.
 Install this package if you wish to develop software that manipulates
 GRASS data sets.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

VERSION=$(shell echo `head -2 $(CURDIR)/include/VERSION`|sed -e 's/ //')
ABI=$(shell echo `head -3 $(CURDIR)/include/VERSION`|sed -e 's/ //g' -e 's/RC/-/')
BASE_NAME=grass$(VERSION)
PKG_NAME=grass

CFLAGS=-Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	STRIP = 
else
	STRIP = strip
endif

TCLINC = /usr/include/tcl

versions: 
	@echo "Version: $(VERSION)"
	@echo "ABI: $(ABI)"

templates: $(patsubst %.in,%,$(wildcard debian/*.in))

debian/% :: debian/%.in
	sed -e 's/@VERSION@/$(VERSION)/' -e 's/@ABI@/$(ABI)/' $< >$@

configure: config.status
config.status: 
	dh_testdir

ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f config.sub config.sub.original
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f config.guess config.guess.original
	cp -f /usr/share/misc/config.guess config.guess
endif

	# Add here commands to configure the package.
	CFLAGS="$(CFLAGS)" ./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) \
                    --prefix=/usr/lib \
                    --sysconfdir=/etc \
                    --sharedstatedir=/var \
                    --enable-socket \
                    --enable-shared \
                    --with-postgres \
                    --with-mysql \
                    --with-cxx \
                    --with-x \
                    --with-gdal \
                    --with-freetype \
                    --with-motif \
                    --with-readline \
                    --with-nls \
                    --with-odbc \
		    --with-sqlite \
		    --enable-largefile \
                    --with-freetype-includes=/usr/include/freetype2 \
                    --with-tcltk-includes=$(TCLINC) \
                    --with-postgres-includes=$(shell pg_config --includedir) \
                    --with-mysql-includes=$(shell mysql_config --include|sed -e 's/-I//') \
		    --with-proj-share=/usr/share/proj \
		    --with-wxwidgets=/usr/bin/wx-config \
		    --with-python=/usr/bin/python-config \
		    --with-cairo

	touch $@

# This target generates arch-dep stuff, unfortunately most doc requires working bins to 
# be properly generated...
build: configure build-stamp
build-stamp:  
	dh_testdir
	$(MAKE) 
	chmod 755 debian/fixpaths.sh debian/fixscripts.sh
	touch $@

# This target generates truly arch-indep stuff
build-indep: configure build-indep-stamp
build-indep-stamp: 
	dh_testdir
	$(MAKE) htmldocs
	touch $@

clean: templates true-clean 
true-clean:
	dh_testdir
	dh_testroot
	
ifneq "$(wildcard /usr/share/misc/config.sub.original)" ""
	mv -f config.sub.original config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess.original)" ""
	mv -f config.guess.original config.guess
endif
	
	# Add here commands to clean up after the build process.
	[ ! -f $(CURDIR)/include/Make/Platform.make ] || $(MAKE) distclean
	dh_clean 
	
	rm -f lib/proj/nad2bin
	rm -f tools/timer/main.o
	rm -f raster/r.le/r.le.setup/polytocell/*.o
	rm -f raster/r.terraflow/IOStream/lib/src/libiostream.a
	rm -f debian/$(BASE_NAME).1
	rm -f error.log
	# clean doxygen documentation (programming man)
	rm -rf doxygenhtml lib/vector/html lib/db/html lib/gis/html \
		lib/vector/latex lib/db/latex lib/gis/latex \
		lib/g3d/html \
		lib/ogsf/html \
		lib/proj/html \
		lib/gmath/html \
		lib/segment/html \
		lib/vector/dglib/html \
		rfc/html \
		lib/g3d/latex \
		lib/ogsf/latex \
		lib/proj/latex \
		lib/gmath/latex \
		lib/segment/latex \
		lib/vector/dglib/latex \
		rfc/latex

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# install grass core into debian/tmp
	$(MAKE) $(STRIP)
	$(MAKE) install \
		INST_DIR=$(CURDIR)/debian/tmp/usr/lib/$(BASE_NAME) \
		PREFIX=$(CURDIR)/debian/tmp/usr/lib/$(BASE_NAME) \
		BINDIR=$(CURDIR)/debian/tmp/usr/bin

	# fix all the braindead scripts
	debian/fixscripts.sh

	# fix links
	debian/fixpaths.sh $(CURDIR)/debian/tmp debian/tmp
	
	# delete extra license files
	rm -f debian/tmp/usr/lib/$(BASE_NAME)/bwidget/LICENSE.txt

	# change section from 1 to .1grass 
	mv debian/tmp/usr/lib/$(BASE_NAME)/man/man1/grass6.1 debian/$(BASE_NAME).1
	for m in debian/tmp/usr/lib/$(BASE_NAME)/man/man1/*.1; do \
		n=`basename $$m .1`; mv $$m debian/tmp/usr/lib/$(BASE_NAME)/man/man1/$$n.1grass; done
	for m in debian/tmp/usr/lib/$(BASE_NAME)/man/man1/*.1grass; do \
		sed -i -e 's/^.TH \(.*\) 1/.TH \1 1grass/' $$m; done

	# install module makefile (redundant due to grass-dev.install?)
	install -m 644 include/Make/Module.make \
		debian/$(PKG_NAME)-dev/usr/lib/$(BASE_NAME)/include/Make/Module.make

	# adjust from build-server build dir to end-user's install dir
	sed -i -e "s+^\(GRASS_HOME[ ]*=\) .*+\1 /usr/lib/$(BASE_NAME)+" \
		-e "s+^\(RUN_GISBASE[ ]*=\) .*+\1 /usr/lib/$(BASE_NAME)+" \
		debian/tmp/usr/lib/$(BASE_NAME)/include/Make/Platform.make

	# install helper scripts for building addon man pages
	install -m 755 tools/mkhtml.sh \
		debian/$(PKG_NAME)-dev/usr/lib/$(BASE_NAME)/tools/mkhtml.sh
	install -m 755 tools/g.html2man/g.html2man \
		debian/$(PKG_NAME)-dev/usr/lib/$(BASE_NAME)/tools/g.html2man

	# install pkg-config file
	install -m 644 grass.pc debian/$(PKG_NAME)-dev/usr/share/pkgconfig/$(BASE_NAME).pc

	# install icon file for debian menu system
	install -d debian/tmp/usr/share/icons \
		debian/tmp/usr/share/applications \
		debian/tmp/usr/bin
	# is there a better way to make these exist?
	mkdir -p debian/tmp/usr/share/icons/hicolor/32x32/apps
	mkdir -p debian/tmp/usr/share/icons/hicolor/48x48/apps
	mkdir -p debian/tmp/usr/share/applications
	install -m 644 debian/grass.xpm \
		debian/tmp/usr/share/icons/hicolor/32x32/apps/$(BASE_NAME).xpm
	install -m 644 gui/icons/grass-48x48.png \
		debian/tmp/usr/share/icons/hicolor/48x48/apps/$(BASE_NAME).png
	install -m 644 gui/icons/grass.desktop \
		debian/tmp/usr/share/applications/$(BASE_NAME).desktop
	# 6.4.1 shipped with "grass65" as the Exec target
	sed -i -e 's+/usr/share/icons/grass-48x48.png+$(BASE_NAME)+' \
		-e 's+grass65+$(BASE_NAME)+' \
		debian/tmp/usr/share/applications/$(BASE_NAME).desktop

	# install x-grass wrapper script
	install -m 755 debian/x-grass debian/tmp/usr/bin/x-grass

	ln -fs /usr/lib/$(shell objdump -p /usr/lib/`gdal-config --libs|cut -d' ' -f2|sed -e 's/-l/lib/'`.so|grep SONAME|cut -d' ' -f18) \
		debian/tmp/usr/lib/$(BASE_NAME)/lib/libgdal.so

install-indep: build-indep
	dh_testdir -i
	dh_testroot -i
	install -m 644  -d debian/tmp
	install -m 644  -d debian/tmp/programming-manual/vector/html/search \
			   debian/tmp/programming-manual/db/html/search \
			   debian/tmp/programming-manual/gis/html/search 
			   
	-install -m 644 lib/vector/html/* debian/tmp/programming-manual/vector/html
	-install -m 644 lib/vector/html/search/* debian/tmp/programming-manual/vector/html/search
	-install -m 644 lib/db/html/* debian/tmp/programming-manual/db/html
	-install -m 644 lib/db/html/search/* debian/tmp/programming-manual/db/html/search
	-install -m 644 lib/gis/html/* debian/tmp/programming-manual/gis/html
	-install -m 644 lib/gis/html/search/* debian/tmp/programming-manual/gis/html/search

# Build architecture-independent files here.
binary-indep: install install-indep 
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs -i CHANGES
	dh_installdocs -i
	dh_install -i
	dh_link -i
	dh_strip -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: install
	dh_testdir -a
	dh_testroot  -a
	dh_installchangelogs -a CHANGES
	dh_installdocs  -a
